function translateAsNormalPart(){
	gsub(/\\verb@/,"<code class=\"filenamedata\">",$0);
	gsub(/@/,"</code>",$0);
	gsub(/\\verb~/,"<code class=\"codedata\">",$0);
	gsub(/~/,"</code>",$0);
	gsub(/\\verb!/,"<code class=\"commanddata\">",$0);
	gsub(/!/,"</code>",$0);


	gsub(/\$\\leadsto\$/,"→",$0);

	translateAsMathPart();

	translateAddhock();

	gsub(/\\begin{remark}/,"",$0);	
	gsub(/\\end{remark}/,"",$0);	
}

function translateAsMathPart(){
     gsub(/\\ZZ/,"\\mathbb{Z}",$0);	
     gsub(/\\QQ/,"\\mathbb{Q}",$0);	
     gsub(/\\FF/,"\\mathbb{F}",$0); 
     gsub(/\\NN/,"\\mathbb{N}",$0); 
     gsub(/\\RR/,"\\mathbb{R}",$0); 
     gsub(/\\CC/,"\\mathbb{C}",$0); 
}

function translateAddhock(){
     gsub(/\\SageNotebook/,"<code>Sage Notebook</code>",$0);	
     gsub(/\\Sage/,"<code>Sage</code>",$0);	
     gsub(/\\defit/,"",$0);	
}

BEGIN {idcounter=1;blocktype=-1;linesinpar=0;itemsinlist=0;}

/\\mainmatter/{if(blocktype<0){blocktype=0;next;}}
/\\backmatter/{blocktype=-1;next;}
/^%/{if(blocktype==0){next;}}

/\\begin{codeblock}/{blocktype=12;}
/\\end{codeblock}/{blocktype=10;}

/\\begin{resultblock}/{blocktype=22;}
/\\end{resultblock}/{blocktype=20;}

/\\begin{commandblock}/{blocktype=32;}
/\\end{commandblock}/{blocktype=30;}

/\\begin{align/{blocktype=42;}
/\\end{align/{blocktype=40;}

/\\begin{itemize}/{blocktype=52;}
/\\end{itemize}/{blocktype=50;}

/\\begin{enumerate}/{blocktype=62;}
/\\end{enumerate}/{blocktype=60;}

/\\begin{description}/{blocktype=52;}
/\\end{description}/{blocktype=50;}



/\\chapter{.*}/{if(blocktype==0){sub(/\\chapter{/,"<h1>");sub(/}/,"</h1>");blocktype=2;}}
/\\section{.*}/{if(blocktype==0){sub(/\\section{/,"<h2>");sub(/}/,"</h2>");blocktype=2;}}
/\\subsection{.*}/{if(blocktype==0){sub(/\\subsection{/,"<h3>");sub(/}/,"</h3>");blocktype=2;}}
/\\subsubsection{.*}/{if(blocktype==0){sub(/\\subsubsection{/,"<h4>");sub(/}/,"</h4>");blocktype=2;}}

/{quote}/{if(blocktype==0){gsub(/\\begin{quote}/,"<blockquote>");
	gsub(/\\end{quote}/,"</blockquote>");}}




{if(blocktype==0)
    {
	translateAsNormalPart();
	if($0 != ""){
	    if(linesinpar==0){print "<p>";linesinpar=1;}
	    print $0;
	}
	if($0 == ""){
	    if(linesinpar>0){print "</p>";linesinpar=0;}
	}
    }
 if(blocktype==1){blocktype=0;}
 if(blocktype==2)
    {
	if(linesinpar>0){print "</p>";linesinpar=0;}
	blocktype=0;
	print $0;
    }

 if(blocktype==10){print "///";print "}}}";blocktype=0;}
 if(blocktype==11)
   {
       gsub(/{}/,"",$0);
       gsub(/\\{/,"{",$0);
       gsub(/\\}/,"}",$0);
       gsub(/\\bs/,"\\",$0);
       gsub(/\\obrace/,"{",$0);
       gsub(/\\cbrace/,"}",$0);
       print $0;
   }
 if(blocktype==12)
   {
       if(linesinpar>0){print "</p>";linesinpar=0;}
       print "{{{id="idcounter"|"; idcounter=idcounter+1;blocktype=11;
   }

 if(blocktype==20){blocktype=0;}
 if(blocktype==21){}
 if(blocktype==22){
     if(linesinpar>0){print "</p>";linesinpar=0;}
     blocktype=21;
 }

 if(blocktype==30){print "</pre>";blocktype=0;}
 if(blocktype==31){print $0;}
 if(blocktype==32){
     if(linesinpar>0){print "</p>";linesinpar=0;}
     print "<pre>";blocktype=31;
 }

 if(blocktype==40){
     print "$$";
     blocktype=0;
 }
 if(blocktype==41){
     translateAsMathPart();
     print $0;
 }
 if(blocktype==42){
     if(linesinpar>0){print "</p>";linesinpar=0;}
     blocktype=41;
     print "$$";
 }


 if(blocktype==50){
     if(itemsinlist>0){
	 print "</li>";
     }
     print "</li></ul>";
     blocktype=0;
 }
 if(blocktype==60){
     if(itemsinlist>0){
	 print "</li>";
     }
     print "</ol>";
     blocktype=0;
 }
 if(blocktype==61){
     if(gsub(/\\item/,"</li><li>",$0)>0){
	 if(itemsinlist==0){
	     sub(/<\/li><li>/,"<li>",$0);	
	     itemsinlist=1;
	 }
     }
     translateAsNormalPart();
     print $0;
 }
 if(blocktype==52){
     if(linesinpar>0){print "</p>";linesinpar=0;}
     blocktype=61;
     print "<ul>";
 }
 if(blocktype==52){
     if(linesinpar>0){print "</p>";linesinpar=0;}
     blocktype=61;
     print "<ol>";
 }

}

END {if(linesinpar>0){print "</p>";linesinpar=0;}}
